/*!
 * \file   include/TFEL/Tests/TestProxy.ixx
 * \author Helfer Thomas
 * \date   10 Apr 10
 * \brief  
 * \copyright Copyright (C) 2006-2014 CEA/DEN, EDF R&D. All rights 
 * reserved. 
 * This project is publicly released under either the GNU GPL Licence 
 * or the CECILL-A licence. A copy of thoses licences are delivered 
 * with the sources of TFEL. CEA or EDF may also distribute this 
 * project under specific licensing conditions. 
 */

#ifndef _LIB_TFEL_TESTS_TESTPROXY_IXX
#define _LIB_TFEL_TESTS_TESTPROXY_IXX 1

#include"TFEL/Utilities/SmartPtr.hxx"
#include"TFEL/Tests/TestManager.hxx"

namespace tfel
{

  namespace tests
  {
    
    template<typename T>
    TestProxy<T>::TestProxy(const std::string& n)
    {
      using namespace tfel::utilities;
      TestManager& tm = TestManager::getTestManager();
      tm.addTest(n,shared_ptr<Test>(new T()));
    } // end of TestProxy<T>::TestProxy

    template<typename T>
    template<typename T2>
    TestProxy<T>::TestProxy(const std::string& n,
			    const T2& t)
    {
      using namespace tfel::utilities;
      TestManager& tm = TestManager::getTestManager();
      tm.addTest(n,shared_ptr<Test>(new T(t)));
    } // end of TestProxy<T>::TestProxy

    template<typename T>
    template<typename T2,
	     typename T3>
    TestProxy<T>::TestProxy(const std::string& n,
			    const T2& t1,
			    const T3& t2)
    {
      using namespace tfel::utilities;
      TestManager& tm = TestManager::getTestManager();
      tm.addTest(n,shared_ptr<Test>(new T(t1,t2)));
    } // end of TestProxy<T>::TestProxy
    
  } // end of namespace test

} // end of namespace tfel

#endif  /*_LIB_TFEL_TESTS_TESTPROXY_IXX */
