/*#! PLEIADES - CAST3M2014 - SOURCE PTRLOI - VERSION 1 (20140630)
 * PTRLOI
 * CALL PTRLOI(LMELIB,LMELGB,LMENOM,LMENGM,LMEPTR)
 *
 * Historique : 
 *  - v0  (2014/06/01)  Version initiale
 *  - v1  (2014/06/30)  Modifs de la longueur maximale pour le nom de la fonction (REX PL)
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>

#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#include <stdio.h>

#define dlopen(name, mode) LoadLibrary (TEXT (name))
#define dlsym(handle, func) GetProcAddress (handle, func)
#define dlclose(handle) FreeLibrary (handle)
#define dlerror() "error %d occurred", GetLastError ()
#else
  #include<dlfcn.h>
#endif

#include "castem.h"
#define ptrloi ptrloi_

#define LMEMAX  72   // Longueur maximale de lmenom (cf. sp. Fortran appellant) sans "\0" final
#define LOCMAX  75   // Au moins = LMEMAX + 2 ("_" + "\0")

void ptrloi(lmelib,lmelgb, lmenom,lmengm, lmeptr)

  char *lmelib ;     // chemin complet de la librairie
  cast_int *lmelgb ; // longueur de lmelib (moins char(0) final)
  char *lmenom ;     // nom du modele/fonction a chercher dans lmelib
  cast_int *lmengm ; // longueur de lmenom (moins char(0) final)
  cast_int* lmeptr ; // pointeur sur la fonction pour appel en Fortran

{
  cast_int i ;
  int m ;
  char locnom[LOCMAX] ;
  void *ptrlib = NULL ;
  void *ptrfct = NULL ;

  *lmeptr = 0 ;

/* Quelques verifications ... */
  i = strlen(lmelib) ;
//DBG  fprintf(stderr,"(VERIF/ptrloi) lmelib='%s'\n",lmelib) ;
//DBG  fprintf(stderr,"(VERIF/ptrloi) len(lmelib)=%d lmelgb=%d\n",(int)i,(int)*lmelgb) ;
  if (*lmelgb != i)
  {
    *lmeptr = -1 ;
    fprintf(stderr,"(ERREUR/ptrloi) lmelgb & lmelib non coherents\n") ;
    return ;
  }
  i = strlen(lmenom) ;
//DBG  fprintf(stderr,"(VERIF/ptrloi) lmenom='%s'\n",lmenom) ;
//DBG  fprintf(stderr,"(VERIF/ptrloi) len(lmenom)=%d lmengm=%d\n",(int)i,(int)*lmengm) ;
  if (*lmengm != i)
  {
    *lmeptr = -2 ;
    fprintf(stderr,"(ERREUR/ptrloi) lmengm & lmenom non coherents\n") ;
    return ;
  }
  if (i > LMEMAX)
  {
    *lmeptr = -3 ;
    fprintf(stderr,"(ERREUR/ptrloi) lmengm > %d !\n",LMEMAX) ;
    return ;
  }

/* On recherche : */
  ptrlib = dlopen(lmelib, RTLD_NOW) ;
  if (ptrlib == NULL)
  {
    *lmeptr = -10 ;
    fprintf(stderr,"(ERREUR/ptrloi) lmelib=%s\n",dlerror()) ;
    return ;
  }
/* Pour eviter des problemes de casse dans le noms de la fonction, on cherche 
 * d'abord le nom tel quel, puis le nom complet en minuscules en cas d'echec, 
 * et enfin en dernier lieu le nom en minuscules suivi du caractere "_" (cas 
 * des fonctions en Fortran). */
  strcpy(locnom,lmenom) ;
//DBG  fprintf(stderr,"(VERIF/ptrloi) locnom='%s' (1)\n",locnom) ;
  ptrfct = dlsym(ptrlib,locnom) ;
  if (ptrfct == NULL)
  {
    m = 0 ;
    while (locnom[m] != '\0')
    {
      locnom[m] = tolower(locnom[m]) ;
      m++ ;
    }
//DBG    fprintf(stderr,"(VERIF/ptrloi) locnom='%s' (2)\n",locnom) ;
    ptrfct = dlsym(ptrlib,locnom) ;
    if (ptrfct == NULL)
    {
      strcat(locnom,"_") ;
//DBG      fprintf(stderr,"(VERIF/ptrloi) locnom='%s' (3)\n",locnom) ;
      ptrfct = dlsym(ptrlib,locnom) ;
      if (ptrfct == NULL)
      {
        *lmeptr = -20 ;
        fprintf(stderr,"(ERREUR/ptrloi) lmenom=%s\n",dlerror()) ;
        return ;
      }
    }
  }
  *lmeptr = ptrfct ;
}

